/*--------------------------------------------------------------------

  World Folio - Offline map viewer/editor for Age of Adventure

  Copyright (c) 2001 Phil Dempster <phil@buxton.port5.com>
  http://buxton.port5.com/age/

  This software is based on an original work the copyright in which
  vests in Interactive Broadcasting Ltd (http://www.ibgames.net/).
  Original programming by Alan Lenton with additional programming by
  Stanley Lenton.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Compiled with Borland C++ Builder 3.

--------------------------------------------------------------------*/

#ifndef AGEMAP_H
#define AGEMAP_H

#include <map>

using namespace std;

class Location;

typedef map< int, Location *,less<int> > LocList;

class AgeMap
{
private:
//    static Graphics::TBitmap    *map_gfx;

    char        title[80];      // the formal title of the map
    LocList loc_list;       // list of locations
    static bool zoom;

    int CheckDiagonalLink(int GridCol,int GridRow,int tile_size);
    int CheckLeftRightLink(int GridCol,int GridRow,int tile_size);
    int CheckUpDownLink(int GridCol,int GridRow,int tile_size);

    bool    CheckExit(int GridCol,int GridRow, int dir);
    bool    IsPossibleLoc(int grid_col,int grid_row);

    void    Clear();

public:
    AgeMap(FILE *file);
    ~AgeMap();
    enum { MAP, DESIGN } filetype;

    static void LoadMapGfx();
    static void DeleteMapGfx();//      { delete map_gfx; return; }

    void    DrawCell(int GridCol,int GridRow,TRect &rect,int tile_size);
    void    Name2Status(int cur_col,int cur_row);
    void    Save(FILE *file);
    void    ShowNotes(int cur_col,int cur_row,int X,int Y);
    void    FindNames(void);
    int     Zoom(void)              { return zoom; }
    void    Zoom(bool z)            { zoom = z;    }
};

#endif
