/*--------------------------------------------------------------------

  World Folio - Offline map viewer/editor for Age of Adventure
  
  Copyright (c) 2001 Phil Dempster <phil@buxton.port5.com>
  http://buxton.port5.com/age/

  This software is based on an original work the copyright in which
  vests in Interactive Broadcasting Ltd (http://www.ibgames.net/).
  Original programming by Alan Lenton with additional programming by
  Stanley Lenton.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Compiled with Borland C++ Builder 3.
    
--------------------------------------------------------------------*/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <stdio>
#include <dir>
#include <dos>

#include "folio.h"
#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TFolioForm *FolioForm;
//---------------------------------------------------------------------------
__fastcall TFolioForm::TFolioForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TFolioForm::FolioListClick(TObject *Sender)
{
    int  idx;

    // Get selected map.
    idx = FolioList->ItemIndex;

    if (idx != -1)  // Nowt selected.
    {
        if (!FolioList->Items->Objects[idx])    // ..then its a directory.
        {
            ReadFolio((FolioList->Items->Strings[idx]).c_str(), "*.map");
        }
        else // ..open the new map. 
        {
            MainForm->LoadMap(((AnsiString*)FolioList->Items->Objects[idx])->c_str());
        }
    }   
}
//---------------------------------------------------------------------------

void __fastcall TFolioForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    MainForm->FolioItem->Checked = false;
}
//---------------------------------------------------------------------------

void TFolioForm::ReadFolio(char *path, char *ext)
{
    // Fill out the map folio list.
    FILE  *file;
    char   buf[256], *p, *dir;
    int    done;
    struct ffblk ffblk;

    FolioList->Enabled = false;
    FolioList->Clear();

    SetCurrentDirectory(path);
    GetCurrentDirectory(sizeof(buf), buf);

    p = strtok(buf, "\\");
    while (p)
    {
        dir = p;
        p   = strtok(0, "\\");
    }
    sprintf(buf, "Map Folio - %s", dir);
    Caption = buf;

    done = findfirst("*.*", &ffblk, FA_DIREC);

    while (!done)
    {
        if (ffblk.ff_attrib & FA_DIREC && strcmp(ffblk.ff_name, ".")!=0)
        {
            FolioList->Items->AddObject(AnsiString(ffblk.ff_name), NULL);
        }
        done = findnext(&ffblk);
    }

    done = findfirst(ext, &ffblk, 0);

    while (!done)
    {
        if((file = fopen(ffblk.ff_name, "r")) != NULL)
        {
            if (fgets(buf, sizeof(buf), file) != NULL);
            {
                // Lose the '\n'.
                *(buf + strlen(buf) - 1) = NULL;

                // FIXME is this a memory leak?
                FolioList->Items->AddObject(AnsiString(buf),
                                           (TObject*)(new AnsiString(ffblk.ff_name)));
            }
            fclose(file);
        }
        done = findnext(&ffblk);
    }
    FolioList->Enabled = true;
}
//---------------------------------------------------------------------------

void __fastcall TFolioForm::FormCreate(TObject *Sender)
{
    ReadFolio(".\\maps", "*.map");
    if (FolioList->Items->Count)
    {
        Show();
    }
}
//---------------------------------------------------------------------------

void __fastcall TFolioForm::FormHide(TObject *Sender)
{
    MainForm->FolioItem->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TFolioForm::FormShow(TObject *Sender)
{
    MainForm->FolioItem->Checked = true;
}
//---------------------------------------------------------------------------

