/*--------------------------------------------------------------------

  World Folio - Offline map viewer/editor for Age of Adventure
  
  Copyright (c) 2001 Phil Dempster <phil@buxton.port5.com>
  http://buxton.port5.com/age/

  This software is based on an original work the copyright in which
  vests in Interactive Broadcasting Ltd (http://www.ibgames.net/).
  Original programming by Alan Lenton with additional programming by
  Stanley Lenton.

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
  General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

  Compiled with Borland C++ Builder 3.
    
--------------------------------------------------------------------*/

#include <vcl.h>
#pragma hdrstop

#include "location.h"
#include "main.h"
#include "index.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TIndexForm *IndexForm;
//---------------------------------------------------------------------------
__fastcall TIndexForm::TIndexForm(TComponent* Owner)
    : TForm(Owner)
{
    find_loc = -1;
}
//---------------------------------------------------------------------------
void __fastcall TIndexForm::IndexListClick(TObject *Sender)
{
    int idx, grid_col, grid_row;
    Location *loc;

    // Get selected map.
    idx = IndexList->ItemIndex;

    if (idx != -1)  // Nowt selected.
    {
        loc = (Location*)(IndexList->Items->Objects[idx]);

        find_loc = loc->Row() * 32 + loc->Column();
        grid_col = (loc->Column() - Location::mincol) * 2;
        grid_row = (loc->Row()    - Location::minrow) * 2;
        
        MainForm->CentreMap(grid_col, grid_row);
    }
}
//---------------------------------------------------------------------------
void __fastcall TIndexForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
    MainForm->IndexItem->Checked = false;
}
//---------------------------------------------------------------------------
void __fastcall TIndexForm::FormHide(TObject *Sender)
{
    MainForm->IndexItem->Checked = false;
}
//---------------------------------------------------------------------------

void __fastcall TIndexForm::FormShow(TObject *Sender)
{
    MainForm->IndexItem->Checked = true;
}
//---------------------------------------------------------------------------

